
`timescale 1ns / 1ps

/////////////////////////////////////////////////////////////////////
// Company:        Atmospheric Plasma Solutions
// Engineer:       Jim Hall
// 
// Create Date:    10/29/2020 
// Design Name:    SAFETY_UNIT_CPLD
// Module Name:    CLOCK_DIVIDER 
// Project Name:   MK1 SAFETY UNIT
// Target Devices: EPM240T100I5N
// Tool versions:  Quartus Prime Lite Edition 20.1.0 Build 711
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
/////////////////////////////////////////////////////////////////////

module clock_divider (clk_in, reset_n, clk_out);
                     
                      

/*
** DEFINES *****************************************
*/
`define TRUE 		1'b1
`define FALSE 		1'b0
`define HI    		1'b1
`define LO    		1'b0

/*
** INPUTS *******************************************
*/
input clk_in;
input reset_n;
/*
** INOUTS *******************************************
*/

/*
** OUTPUTS ******************************************
*/
output clk_out;

/*
** PARAMETERS ***************************************
*/
parameter COUNTER_SIZE = 25;
parameter MAX_COUNT = 25'h1FFFFFF;
/*
** SIGNAL DECLARATIONS ******************************
*/
reg  clk_out;
reg  [(COUNTER_SIZE-1):0]  clk_in_count;
reg  toggle_state;

/*
** LOWER LEVEL MODULE INSTANTIATIONS ****************
*/

/*
** ASSIGN STATEMENTS ********************************
*/

/*
** PROCEDURAL CODE **********************************************
*/
always@(posedge clk_in or negedge reset_n) 
begin
  if (~reset_n)
  begin
    clk_out      <= `LO;
    clk_in_count <= 25'd0;
  end
  else
  begin
    if (toggle_state)
    begin
      clk_out      <= ~clk_out;
      clk_in_count <= 25'd0;
    end
    else
    begin
      clk_in_count  <= (clk_in_count + 1);
    end
  end
end

always@(clk_in_count)
begin
  case (clk_in_count)
    MAX_COUNT:   toggle_state = `TRUE;
    default:     toggle_state = `FALSE;
  endcase 
end
       
endmodule // clock_divisor()
